c  simple program that takes the difference between 2
c   time series;  however, to do this, it needs to
c   sense missing data from either time series and not
c    perform the difference; only output difference when both
c   data exist
c  
c  Modification to diff_dat to include time lag in second file
      double precision time1(300000), time2, fjul1(3000000), 
     & decday, fjul2
      dimension year(300000), dat1(300000), err(300000)
      character*80 ifile1, ifile2,ofile3
      nmax=300000
      print*,' adds two time series'
c      print*,'   second time series subtracted from first'
      print*,' Input name of first time series'
      read(5,100)ifile1
100   format(a80)
      print*,' Input name of second time series'
      read(5,100)ifile2
      print*,' Input name of outpute time series'
      read(5,100)ofile3
      open(1,file=ifile1)
      open(2,file=ifile2)
      open(3,file=ofile3)
      print*,'  Input time lag/lead in days of second file'
c  lead/lag time handled same way as est_noise6
      read(5,*)tlag
      print*,' the lead/lag time is ', tlag
c  input first time series
      i=0
1     continue
        i=i+1
        read(1,*,end=10)year(i),fjul1(i),dat1(i), err(i)
        decday=fjul1(i)-int(fjul1(i))
        call jul2day(int(year(i)),int(fjul1(i)),iday)
        if (i .eq. 1) iday0=iday
        time1(i)=float(iday-iday0)+decday
c        if (i .eq. 1) print*,i,time1(i),year(i),fjul1(i), dat1(i)
        go to 1
10    continue
      ndat1=i-1
      if (ndat1 .gt. nmax) then
         print*,' Number of data in 1st file', ndat1,
     &   ' exceeds dimension', nmax
         stop
      end if
c smallest time interval
      dt=999999.
      do 12 i=2,ndat1
      if (time1(i)-time1(i-1) .lt. dt) dt=time1(i)-time1(i-1)
12    continue
      print*,' smallest time interval in 1st time series',
     &   dt,' days'
      ic=1
c  input the second time series;
      ndat2=0
      ndat3=0
11    continue
        read(2,*,end=20)year2,fjul2,dat2
        ndat2=ndat2+1
        decday=fjul2-int(fjul2)
        call jul2day(int(year2),int(fjul2),iday) 
        time2=float(iday-iday0)+decday-tlag
        if (time2 .gt. time1(ndat1)) then
           go to 20
        end if
c
c   increment ic until 1) time1 and time2 match, or, time1 > time2
c
13      continue
c        if (ic .gt. ndat1) go to 20
        if (abs(time1(ic) -time2) .lt. 0.1*dt) then
          write(3,101)year(ic),fjul1(ic),dat1(ic)+dat2, err(ic)
101       format(1x,f6.0,f15.9,f15.2,f8.1)
          ndat3=ndat3+1
          go to 11
        end if
        if (time1(ic) - time2 .gt. 0.1*dt) then
           if (ic .gt. 11) ic =ic-10
           go to 11
        end if
        if (time1(ic) - time2 .lt. -0.1*dt) then
           ic=ic+1
           go to 13
        end if
20      continue
      print*,' Number of data in 1st file', ndat1

      print*,' Number of data in 2nd file', ndat2
      print*,' Number of data output is', ndat3

         
       


      close(3)
      close(2)
      close(1)
      stop
      end
      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1
 
      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
