      integer yr, jul
      dimension d(35000000),dout(35000000)
      double precision fjul,day, dayarray(35000000),day0,ddt,deltat
      character*40 infile, outfile
      character*5 forcode
      max=35000000
      fmiss=999999.
      print*,' Name of the input file which is formated jl'
      read(5,100)infile
100   format(a40)
      open(1,file=infile)
      print*,' Name of the output file'
      read(5,100)outfile
      open(2,file=outfile)
      print*,' Input the format code, wr/bot'
      read(5,101)forcode
101   format(a5)
      i=1
      deltat=99999.
1     continue
        if (i .gt. max) then
           print*,' number of data read', i,' exceeds dimension', max
           print*,' bailing'
           stop
        end if
        read(1,*,end=10)fyr,fjul,d(i),x
        call jul2day(int(fyr),int(fjul),iday)
 
        day=float(iday)+fjul-int(fjul)

        if (i .eq. 1) day0=day
        dayarray(i)=day
        if (i .gt. 1) then
          dt=dayarray(i)-dayarray(i-1)
          if (dt .lt. deltat) deltat=dt
        end if
c        if (dt .lt. 0.0 ) then
c          print*,' dt less than zero',dt
c          print*,' failing at observation ',i
c          print*,' time is',fyr,fjul,day
c       end if
        i=i+1
        go to 1
10    continue
      npts=i-1
      print*,' number of data read is', npts
      print*,' smallest sampling interval is ',deltat,' days'
      if ( deltat .gt. 1.0d+0 ) then
        print*,'  force sampling interval to be one day'
        deltat=1.0d+0
      end if
c      if ( deltat .ge. 1.0d+0) then 
c         deltat=float(int(deltat+0.2))
c         ddt=1.0*deltat
c      end if
c      print*,' hour', deltat,1.0d+0 - 1.0/(2.0*(24.*60.))
c      if ( deltat .lt. 1.0d+0 - 1.0/(2.0*(24.*60.))) 
c     &      deltat=(24.0d+0)*deltat
c      if ( deltat .ge. 1.0d+0) then
c         deltat=float(int(deltat+0.2))
c         ddt=deltat/24.0d+0
c      end if
c      print*,' smallest sampling interval is ',deltat,' hours'
c      print*,' min', deltat,  1.0d+0 - 1.0/(2.*60.)
c      if (deltat .lt. 1.0d+0 - 1.0/(2.*60.)) deltat=(60.0d+0)*deltat
c      print*,' new deltat', deltat
c      if (deltat .gt. 1.0d+0 + 1.0/(2.*60.)) then
c         deltat=float(int(deltat+0.2))
c         ddt=deltat/(60.0D+0*24.D+0)
c      end if
      deltat=(60.0d+0)*(24.0d+0)*deltat
      deltat=float(int(deltat+0.001))
      ddt=deltat/(60.0D+0*24.D+0)
      print*,' smallest samplint interval is ',deltat/60.,' hours'
      print*,' smallest sampling interval is ',deltat,' minutes' 
      print*,' ddt=',ddt
      sample=(dayarray(npts)-dayarray(1))/ddt
      print*,sample
      nsample=ifix(sample)+ 1
      print*,' number of samples', nsample
      do 20 i=1,2*nsample
20    dout(i)=fmiss
      do 25 i=1,npts
        dt1=(dayarray(i)-day0)/ddt
        j=int(dt1+0.1)
c        print*,i,dayarray(i),dt1,j+1
        dout(j+1)=d(i)
        if ((j+1) .gt. max) then
          print*,' number samples', j+1,' exceeds dimension', max
           print*,' bailing'
           stop
        end if 
25    continue
      if (forcode .eq. "bot" ) then
        do 30 i=1,nsample
          write(2,*)dout(i)
30       continue
      end if
      if (forcode .eq. "wr" ) then
        do 40 i=1,nsample
          iday=int(day0+(i-1)*ddt +0.00)
          call invcal(iday,iyr,imon,idm)
          frac= day0+(i-1)*ddt-float(iday)
          ihr=int(24.0*frac+0.01)
c          frac=frac-24.0*ihr
          frac=24.0*frac-float(ihr)
          imn=int(frac*60.0+0.01)
c          write(2,*)day0+(i-1)*ddt,imon,idm,iyr,ihr,imn, dout(i)
          write(2,103)imon,idm,iyr,ihr,imn, dout(i)
c,frac*60.0+0.01
103       format(2i3,i5,2i3,f18.6)
40       continue
      end if
      close(1)
      close(2)

      stop
      end
       subroutine invcal(day,yr1,mn,date)
c
c inverse calender function
c
c  give day number relative to jan 1, 1980
c  output dat yr, month and day
c
       integer day,yr,mn,date,yr1
       integer year(60),month(22),lmnth(22)
c       data (year(i),i=1,20)/0,366,731,1096,1462,1827,2192,2557,2923,
c     1  3288,3653,4018,4384,4749,5114,5479,5845,6210,6575,6940/
       data (month(i),i=1,13)/0,31,59,90,120,151,181,212,243,273,304,
     1                           334,365/
       data (lmnth(i),i=1,13)/0,31,60,91,121,152,182,213,244,274,305,
     1                          335,366/
       icnt=-365
       icnt=-364
       do 40 j=1,60
         jj=j+2
         xx=float(jj)/4 - (ifix(jj/4.))
         if (xx .ne. 0) add=365
         if (xx .eq. 0) add=366
c         ixx=ifix(jj/4.) - int(jj/4)
c         if (ixx .ne. 0) add=365
c         if (ixx .eq. 0) add=366
         icnt=icnt+add
         year(j)=icnt
c         print*,j,year(j)
40     continue
                                                                                                      
c select the year
       yr=0
1      continue
       if (day .lt. year(yr+1)) go to 5
       yr=yr+1
       go to 1
5      continue
       yr=yr-1
       id=day-year(yr+1)+1
       yr=yr+60
       yr1=yr+1900
c  leap year sense
       if ((yr .eq. 80) .or. (yr .eq. 84) .or. (yr .eq. 88) .or.
     & (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100) .or.
     & (yr .eq. 104) .or. (yr .eq. 108) .or. (yr .eq. 112) .or.
     & (yr .eq. 60) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     & (yr .eq. 72) .or. (yr .eq. 76)) go to 20
c  select the month
       mn=1
7      continue
c       print*,id,month(mn)
       if (id .le. month(mn)) go to 10
       mn=mn+1
       go to 7
10     mn=mn-1
       date=id-month(mn)
       return
c  select month for the leap year
20     continue
       mn=1
27     continue
       if (id .le. lmnth(mn)) go to 30
       mn=mn+1
       go to 27
30     mn=mn-1
       date=id-lmnth(mn)
       return
       end

      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1
      if (yr .gt. 112 ) iday=iday+1
                                                                                                      
      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
